package lcsb.mapviewer.model.map.species.field;

import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;

import lcsb.mapviewer.common.exception.InvalidArgumentException;

@Entity
@DiscriminatorValue("ABSTRACT_REGION_MODIFICATION")
public abstract class AbstractRegionModification extends ModificationResidue {

  private static final double DEFAULT_SIZE = 10;

  private static final long serialVersionUID = 1L;

  public AbstractRegionModification() {
    super();
    this.setWidth(DEFAULT_SIZE);
    this.setHeight(DEFAULT_SIZE);
  }

  public AbstractRegionModification(final AbstractRegionModification mr) {
    super(mr);
  }

  public AbstractRegionModification(final String idModificationResidue) {
    super(idModificationResidue);
  }

  /**
   * Update data in this object from parameter (only if values in parameter
   * object are valid).
   * 
   * @param mr
   *          object from which we are updating data
   */
  public void update(final AbstractRegionModification mr) {
    if (this.getIdModificationResidue() != null && !this.getIdModificationResidue().equals("")
        && !this.getIdModificationResidue().equals(mr.getIdModificationResidue())) {
      throw new InvalidArgumentException("Cannot update from mr with different id");
    }
    if (mr.getWidth() > 0 && mr.getWidth() != DEFAULT_SIZE) {
      this.setWidth(mr.getWidth());
    }
    if (mr.getHeight() > 0 && mr.getHeight() != DEFAULT_SIZE) {
      this.setHeight(mr.getHeight());
    }
    if (mr.getName() != null) {
      this.setName(mr.getName());
    }
    if (mr.getX() != null) {
      this.setX(mr.getX());
    }
    if (mr.getY() != null) {
      this.setY(mr.getY());
    }
  }
}