package lcsb.mapviewer.persist;

import lcsb.mapviewer.model.security.Privilege;
import lcsb.mapviewer.model.security.PrivilegeType;
import lcsb.mapviewer.model.user.User;
import lcsb.mapviewer.persist.dao.security.PrivilegeDao;
import lcsb.mapviewer.persist.dao.user.UserDao;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.annotation.Rollback;
import org.springframework.transaction.annotation.Transactional;

@Transactional
@Rollback(true)
public abstract class PersistTestFunctions extends PersistTestFunctionsNoTransaction {

  protected static Logger logger = LogManager.getLogger();

  @Autowired
  protected UserDao userDao;

  @Autowired
  protected PrivilegeDao privilegeDao;

  protected User createUser() {
    final User user = new User();
    user.setName("John");
    user.setSurname("Doe");
    user.setEmail("john.doe@uni.lu");
    user.setLogin("john.doe");
    user.setCryptedPassword("passwd");
    userDao.add(user);
    return user;
  }

  protected void grantAccess(final User user, final PrivilegeType type, final String objectId) {
    final Privilege privilege = privilegeDao.getPrivilegeForTypeAndObjectId(type, objectId);
    user.addPrivilege(privilege);
    userDao.update(user);
  }

}
